$set noverify
$set noon
$set proc/priv=all
$set on
$on warning then goto fxp
$on error then goto fxp
$jxfix/all
$! FilRst.com
$! Copyright (c) 1994 Glenn C. Everhart. All Rights Reserved.
$! Input:
$! @filrst dbnam zfid1 zfid2 size origname linkdvc
$! We shall presume the "file.typ" is actually a complete file spec
$! here. It is passed to filsav too, so we need only pick a unique
$! save name that can be restored & copy to delsav. Use backup to
$! do the copy so attrs & ownership can be preserved.
$! We use the same code from filsav routine to compute the saved
$! name so things get restored correctly. By using back/overlay we
$! ensure ownership &c. are preserved.
$ on warning then exit
$ file :==$gcy$sys:file
$ unzip:==$gcy$sys:unzip
$ indb=p1
$ infil=p5
$ if infil .eqs. "" .or. infil .eqs. "NONAME" then exit
$ inhx1=p2
$ inhx2=p3
$ insiz=p4
$ svdvc=p6
$ dvc=f$parse(infil,,,"device","syntax_only")
$ dvc=f$edit(dvc,"collapse,upcase")
$ delroot = f$trnlnm("DELSAV")
$ if delroot .eqs. "" then exit
$ delroot = delroot - "]"
$! Above assumes delsav is something like dev:[directory] and we
$! will want to turn it into dev:[directory.subdir]
$ fncmd="$filenum = %x"+inhx1
$ 'fncmd'
$ filenum = filenum / 256
$ fnmsk=%x1ff
$ filenum = filenum .and. fnmsk
$ delsub = dvc - ":" + f$string(filenum)
$ delroot = delroot + "." + delsub + "]"
$! Now delroot is the directory where the file should go, named by device
$! and file number group. (This will also keep files apart by device nicely)
$!
$! First ensure there's room on the device for the file. If there is
$! not, call the routine to make room. (NO sense using compiled code
$! for this...really easy to do it here.)
$ space=f$getdvi(dvc,"freeblocks")
$ need=0
$ need='insiz'
$ need=need+10
$! Allow a little room for headers etc.
$ if need .ge. space
$ then
$  delneed = need - space
$  @gcy$cm:makspc 'indb' f$string(delneed)
$ endif
$ fnam=f$parse(infil,,,"name","syntax_only")+f$parse(infil,,,"type","syntax_only")
$ fnam=f$edit(fnam,"collapse,upcase")
$ if f$length(fnam) .gt. 20 then fnam=f$extract(0,20,fnam)
$ ofilnm=delroot+inhx1+inhx2+fnam
$ ofilnm=f$edit(ofilnm,"collapse,upcase")
$! if svdvc .nes. ""
$! then
$! sdvc=f$edit(svdvc,"collapse,upcase")
$! if f$length(sdvc) .gt. 2 then ofilnm = sdvc
$! endif
$ ! move the file
$ curdef=f$environment("default")
$ if f$trnlnm("GCY$ZIPHSC") .eqs. "YES")
$ then
$  set def 'delroot'
$! Deompress the file we moved to nearline. (Note that if nearline isn't
$! disk, we should compress & decompress in a scratch area. If backing
$! store is tape this would be so.)
$  ofzip=inhx1+inhx2+fnam-"."-";"
$  ofzip=f$extract(0,38,fnam)
$  ofzip=f$edit(ofilnm,"collapse,upcase")
$  unzip "-Xjqq" 'ofzip' 'ofilnm'
$  delete 'ofzip'.zip.
$  set def 'ourdef'
$ endif
$ set file/backup 'infil'
$ lenin=f$length(infil)
$ if f$locate(".DIR",infil) .lt.lenin then exit 4
$ lenin = f$length(ofilnm)
$ if f$locate(".DIR",ofilnm) .lt.lenin then exit 4
$ backup/trunc/overlay/ign=inter 'ofilnm' 'infil'/by_owner
$ ! now truncate the original
$ osiz=f$file_attributes(infil,"eof")
$! delete the saved copy after inswap. Keep it clean.
$ dfilnm=ofilnm+";"
$ delete 'dfilnm'
$JTauthmaint :==$gcy$sys:JTauthmaint
$! Now remove the marking. Code treats JTauthmaint as a special image that
$! is not messed with.
$ JTauthmaint 'infil'\X+
$ JTauthmaint 'infil'\%DELETE
$jxfix/normal
$exit 1
$fxp:
$jxfix/normal
$ exit 8
